/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "uart.h"
#include "usb.h"
#include "usb_req_class.h"
#include "util.h"
#include "timer.h"

BOOL Uart1TxBusy;
BOOL Uart2TxBusy;

BYTE Uart1RxRptr;
BYTE Uart2RxRptr;
BYTE Uart1RxWptr;
BYTE Uart2RxWptr;

BYTE Uart1TxRptr;
BYTE Uart2TxRptr;
BYTE Uart1TxWptr;
BYTE Uart2TxWptr;

BYTE xdata Uart1RxBuffer[256];
BYTE xdata Uart2RxBuffer[256];
BYTE xdata Uart1TxBuffer[256];
BYTE xdata Uart2TxBuffer[256];
#ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
	struct Irc_select xdata IRC[4];
#endif
void uart_init()
{
    SCON = 0x50;
    TMOD &= ~0xf0;
    TL1 = BR(MAIN_Fosc,115200);
    TH1 = BR(MAIN_Fosc,115200) >> 8;
    AUXR |= T1x12;
    TR1 = 1;
    ES = 1;
    
    S2CON = 0x50;
    T2L = BR(MAIN_Fosc,115200);
    T2H = BR(MAIN_Fosc,115200) >> 8;
    AUXR |= T2x12;
    AUXR |= T2R;
    IE2 |= ES2;

    LineCoding1.dwDTERate = REV4(115200);
    LineCoding1.bCharFormat = 0;
    LineCoding1.bParityType = 0;
    LineCoding1.bDataBits = 8;

    LineCoding2.dwDTERate = REV4(115200);
    LineCoding2.bCharFormat = 0;
    LineCoding2.bParityType = 0;
    LineCoding2.bDataBits = 8;
    
    Uart1TxBusy = 0;
    Uart2TxBusy = 0;
    Uart1RxRptr = 0;
    Uart2RxRptr = 0;
    Uart1RxWptr = 0;
    Uart2RxWptr = 0;
    Uart1TxRptr = 0;
    Uart2TxRptr = 0;
    Uart1TxWptr = 0;
    Uart2TxWptr = 0;
#ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
	
	IRC[0].mainFosc		= 22118400UL;			// 0...22.1184M
	IRC[0].txxmAddr		= T22M_ADDR;
	IRC[0].vrtxxmAddr	= VRT27M_ADDR;
	IRC[0].ircBand		= IRCBAND_27M;

	IRC[1].mainFosc		= 24000000UL;			// 1...24M
	IRC[1].txxmAddr		= T24M_ADDR;
	IRC[1].vrtxxmAddr	= VRT27M_ADDR;
	IRC[1].ircBand		= IRCBAND_27M;

	IRC[2].mainFosc		= 30000000UL;			// 2...30M
	IRC[2].txxmAddr		= T30M_ADDR;
	IRC[2].vrtxxmAddr	= VRT27M_ADDR;
	IRC[2].ircBand		= IRCBAND_27M;

	IRC[3].mainFosc		= 40000000UL;			// 3...40M
	IRC[3].txxmAddr		= T40M_ADDR;
	IRC[3].vrtxxmAddr	= VRT44M_ADDR;
	IRC[3].ircBand		= IRCBAND_44M;
#endif
}

void uart1_isr() interrupt UART1_VECTOR
{
    BYTE dat;
    
    if (TI)
    {
        TI = 0;
        Uart1TxBusy = 0;
    }

    if (RI)
    {
        RI = 0;
        dat = SBUF;
        Uart1TxBuffer[Uart1TxWptr++] = dat;
    }
}

void uart2_isr() interrupt UART2_VECTOR
{
    if (S2CON & S2TI)
    {
        S2CON &= ~S2TI;
        Uart2TxBusy = 0;
    }

    if (S2CON & S2RI)
    {
        S2CON &= ~S2RI;
        Uart2TxBuffer[Uart2TxWptr++] = S2BUF;
    }
}

void uart_set_parity()
{
    if (Interface == 0)
    {
        switch (LineCoding1.bParityType)
        {
        default:
        case NONE_PARITY:
            SCON = 0x50;
            break;
        case ODD_PARITY:
        case EVEN_PARITY:
        case MARK_PARITY:
            SCON = 0xd8;
            break;
        case SPACE_PARITY:
            SCON = 0xd0;
            break;
        }
    }
    else if (Interface == 2)
    {
        switch (LineCoding2.bParityType)
        {
        default:
        case NONE_PARITY:
            S2CON = 0x50;
            break;
        case ODD_PARITY:
        case EVEN_PARITY:
        case MARK_PARITY:
            S2CON = 0xd8;
            break;
        case SPACE_PARITY:
            S2CON = 0xd0;
            break;
        }
    }
}

#ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
//========================================================================
// : void SetMCLK(u8 clk)
// : Ƶ
// : clk: Ƶ
// : none.
// 汾: VER1.0
// : 2022-10-14
// ע: 
//========================================================================
void SetMCLK(BYTE clk) //Ƶ
{
	if(MAIN_Fosc == IRC[clk].mainFosc) return;
	MAIN_Fosc = IRC[clk].mainFosc;
	CLKDIV = 0x04;
	IRTRIM = IRC[clk].txxmAddr;						//TxxM_ADDR;
	VRTRIM = IRC[clk].vrtxxmAddr;					//VRTxxM_ADDR;
	IRCBAND = (IRCBAND & ~0x03) | IRC[clk].ircBand;	//IRCBAND_xxM;
	CLKDIV = 1;
}
#endif

void uart_set_baud()
{
    DWORD baud,baud2;
    WORD temp,temp2;
    
    if (Interface == 0)
    {
        baud = LineCoding1.dwDTERate;
        baud2 = LineCoding2.dwDTERate;
    }
    else if (Interface == 2)
    {
        baud = LineCoding2.dwDTERate;
        baud2 = LineCoding1.dwDTERate;
    }
    
    baud = reverse4(baud);

#ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
    baud2 = reverse4(baud2);
    switch (baud)
    {
        case 14400:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 19200:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 28800:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 38400:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 57600:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 115200:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 230400:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 460800:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 921600:
            SetMCLK(0); //ʱ 22.1184MHz
        break;
        case 1500000:
            SetMCLK(2); //ʱ 30MHz
        break;
        default:
            if(baud < 1000000)
                SetMCLK(1); //ʱ 24MHz
            else
                SetMCLK(3); //ʱ 40MHz
        break;
    }
    timer_init();
#endif
    temp = BR(MAIN_Fosc,baud);
    temp2 = BR(MAIN_Fosc,baud2);
    
    if (Interface == 0)
    {
        TL1 = temp;
        TH1 = temp >> 8;
        #ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
        T2L = temp2;
        T2H = temp2 >> 8;
        #endif
    }
    else if (Interface == 2)
    {
        T2L = temp;
        T2H = temp >> 8;
        #ifdef Dynamic_Frequency        //ʶ̬Ƶƿ
        TL1 = temp2;
        TH1 = temp2 >> 8;
        #endif
    }
}

void uart_polling()
{
    BYTE dat;
    BYTE cnt;

    if (DeviceState != DEVSTATE_CONFIGURED)
        return;

    if (!Ep4InBusy && (Uart1TxRptr != Uart1TxWptr))
    {
        IE2 &= ~EUSB;
        Ep4InBusy = 1;
        usb_write_reg(INDEX, 4);
        cnt = 0;
        while (Uart1TxRptr != Uart1TxWptr)
        {
            usb_write_reg(FIFO4, Uart1TxBuffer[Uart1TxRptr++]);
            cnt++;
            if (cnt == EP4IN_SIZE) break;
        }
        usb_write_reg(INCSR1, INIPRDY);
        IE2 |= EUSB;
    }

    if (!Ep5InBusy && (Uart2TxRptr != Uart2TxWptr))
    {
        IE2 &= ~EUSB;
        Ep5InBusy = 1;
        usb_write_reg(INDEX, 5);
        cnt = 0;
        while (Uart2TxRptr != Uart2TxWptr)
        {
            usb_write_reg(FIFO5, Uart2TxBuffer[Uart2TxRptr++]);
            cnt++;
            if (cnt == EP5IN_SIZE) break;
        }
        usb_write_reg(INCSR1, INIPRDY);
        IE2 |= EUSB;
    }

    if (!Uart1TxBusy && (Uart1RxRptr != Uart1RxWptr))
    {
        dat = Uart1RxBuffer[Uart1RxRptr++];
        Uart1TxBusy = 1;
        switch (LineCoding1.bParityType)
        {
        case NONE_PARITY:
        case SPACE_PARITY:
            TB8 = 0;
            break;
        case ODD_PARITY:
            ACC = dat;
            TB8 = !P;
            break;
        case EVEN_PARITY:
            ACC = dat;
            TB8 = P;
            break;
        case MARK_PARITY:
            TB8 = 1;
            break;
        }
        SBUF = dat;
#ifdef ISPPWRCTRL
        //ISPʱ7Fм
       {
            extern BYTE IspCount7F;
            
            if (dat == 0x7f)
                IspCount7F++;
            else
               IspCount7F = 0;
        }
#endif
//        while (Uart1TxBusy);
    }

    if (!Uart2TxBusy && (Uart2RxRptr != Uart2RxWptr))
    {
        dat = Uart2RxBuffer[Uart2RxRptr++];
        Uart2TxBusy = 1;
        switch (LineCoding2.bParityType)
        {
        case NONE_PARITY:
        case SPACE_PARITY:
            S2CON &= ~S2TB8;
            break;
        case ODD_PARITY:
            ACC = dat;
            if (!P)
            {
                S2CON |= S2TB8;
            }
            else
            {
                S2CON &= ~S2TB8;
            }
            break;
        case EVEN_PARITY:
            ACC = dat;
            if (P)
            {
                S2CON |= S2TB8;
            }
            else
            {
                S2CON &= ~S2TB8;
            }
            break;
        case MARK_PARITY:
            S2CON |= S2TB8;
            break;
        }
        S2BUF = dat;

#ifdef ISPPWRCTRL
        //ISPʱ7Fм
       {
            extern BYTE IspCount7F;
            
            if (dat == 0x7f)
                IspCount7F++;
            else
               IspCount7F = 0;
        }
#endif
//        while (Uart2Busy);
    }

    if (Ep4OutBusy)
    {
        IE2 &= ~EUSB;
        if ((BYTE)(Uart1RxWptr - Uart1RxRptr) < (BYTE)(256 - EP4OUT_SIZE))
        {
            Ep4OutBusy = 0;
            usb_write_reg(INDEX, 4);
            usb_write_reg(OUTCSR1, 0);
        }
        IE2 |= EUSB;
    }

    if (Ep5OutBusy)
    {
        IE2 &= ~EUSB;
        if ((BYTE)(Uart2RxWptr - Uart2RxRptr) < (BYTE)(256 - EP5OUT_SIZE))
        {
            Ep5OutBusy = 0;
            usb_write_reg(INDEX, 5);
            usb_write_reg(OUTCSR1, 0);
        }
        IE2 |= EUSB;
    }
}
/*
void UART_SendPacket(uchar *puts,uint len)
{
uint	i;
    for (i=0;i<len;i++)
	{
		Uart1TxBusy = 1;		//־æ
		SBUF = puts[i];		//һֽ
		while(Uart1TxBusy);	//ȴ
	}
}
*/